=== debian/changelog ===
crowdsec (1.4.6-6ubuntu0.24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update 

 -- Evan Caville <evan.caville@canonical.com>  Fri, 20 Jun 2025 14:45:28 +1000

crowdsec (1.4.6-6ubuntu0.24.04.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.21 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 10 Jul 2024 12:19:01 +0530

crowdsec (1.4.6-6build1) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:13:32 +1200

crowdsec (1.4.6-6) unstable; urgency=medium

  * Disable unreliable TestStreaming test, as seen under autopkgtest
    (https://github.com/crowdsecurity/crowdsec/issues/2352):
     - 0019-disable-unreliable-test-TestStreaming.patch

 -- Cyril Brulebois <cyril@debamax.com>  Fri, 14 Jul 2023 20:54:27 +0200

crowdsec (1.4.6-5) unstable; urgency=medium

  * Fix default acquis.yaml to also include the journalctl datasource,
    limited to the ssh.service unit, making sure acquisition works even
    without the traditional auth.log file (Closes: #1040976):
     - 0017-fix-default-acquisition.patch
  * Make sure an invalid datasource doesn't make the engine error out,
    making it possible to include the journalctl datasource in the default
    config file unconditionally, without having to worry whether
    journalctl is actually deployed and usable:
     - 0018-non-fatal-errors-for-invalid-datasources.patch

 -- Cyril Brulebois <cyril@debamax.com>  Thu, 13 Jul 2023 17:23:01 +0200

crowdsec (1.4.6-4) unstable; urgency=medium

  * Implement support for pending registration: since bouncers list crowdsec
    in Recommends, we cannot guarantee the order in which bouncers and
    crowdsec are configured (See: #1035499, #1036985). Bouncers can now
    queue triplets (systemd unit name, bouncer identifier and API key) in
    /var/lib/crowdsec/pending-registration. crowdsec.postinst will register
    those bouncers, and start their systemd units after removing that file
    (satisfying their ConditionPathExists=! on it).
  * Replace `exit 0` with `break` in the preceding code block.

 -- Cyril Brulebois <cyril@debamax.com>  Wed, 31 May 2023 18:54:17 +0200

crowdsec (1.4.6-3) unstable; urgency=medium

  * When performing an upgrade from pre-1.4.x versions, apply a workaround
    to avoid losing CAPI decisions for several hours (Closes: #1033138):
    delete alert(s) matching “Community blocklist”, and if at least one
    deletion occurred, restart the daemon to force an immediate pull.
  * Hardcode libsqlite3-0 (>= 3.35.0) in Depends to ensure Ent-generated
    SQLite queries are understood (Closes: #1033132): otherwise, we would
    get a dependency on libsqlite3-0 (>= 3.12.0) via shlibs, which is
    clearly not enough.
  * Backport upstream patch to fix building in the past/in the future (as
    seen with reproducible builds), no longer hardcoding the expected year
    for yearless timestamps:
     - 0016-try-to-make-reproducible-build-work-2119.patch

 -- Cyril Brulebois <cyril@debamax.com>  Sun, 19 Mar 2023 00:25:07 +0100

crowdsec (1.4.6-2) unstable; urgency=medium

  * Prefix package version with `v` when setting BUILD_VERSION, e.g.
    crowdsec/v1.4.6-2-linux-debian (Closes: #1031324).
  * Stop shipping a logrotate configuration snippet, as crowdsec rotates
    logs on its own via lumberjack.Logger, and that can be configured in
    the main configuration file (/etc/crowdsec/config.yaml):
     - Delete debian/crowdsec.logrotate
     - Add debian/crowdsec.conffiles, marking /etc/logrotate.d/crowdsec
       with the remove-on-upgrade flag.
  * When purging the package, remove internally-rotated log files, in
    addition to removing main log files and the logrotate-generated ones.
  * Really enable upstream-recommended collections, not just the items
    they require: everything would work fine without this, but those
    collections wouldn't appear in `cscli collections list`, and they
    wouldn't be upgraded if admins decided to switch to the online hub.
  * Compensate for the missing collections when upgrading from 1.4.6-1
    specifically (including binNMUs).
  * Enable the crowdsecurity/whitelists parser as well.
  * When performing a fresh install (as determined by the postinst's being
    called with just `configure`), and when /run/systemd/system exists,
    apply a workaround for upstream issue #2120 based on crowdsec.log:
     - Exit immediately if the unit is not active (e.g. the admin masked
       it before installing the package).
     - Check whether entries are received from the Central API, and exit
       if that's the case.
     - Check whether `received 0 new entries` is logged, and restart then
       exit if that's the case.
     - Repeat those checks every second, up to 20 times.
  * When performing an upgrade from pre-1.4.x versions, apply a workaround
    to avoid huge delays at the `restart` step: lower TimeoutStopSec from
    90s (default) to only 20s, using a runtime override (Closes: #1031326).
  * Add a dh_install-indep override to get rid of files left over after
    running the test suite (Closes: #1031328).

 -- Cyril Brulebois <cyril@debamax.com>  Fri, 17 Mar 2023 14:42:04 +0100

crowdsec (1.4.6-1) unstable; urgency=medium

  * New upstream release (Closes: #1031322).
  * Include a snapshot of hub files from the v1.4.6 branch, at commit
    f23a543a80.
  * Delete patch:
     - 0012-work-around-buggy-testparse-test.patch (fixed upstream)
  * Extend patch to avoid crowdsecurity/linux's being marked tainted:
     - 0004-disable-geoip-enrich.patch
  * Extend patch to skip more unreliable tests:
     - 0013-skip-flakky-tests.patch
  * Add patches:
     - 0014-silence-yaml-patching.patch: avoid polluting cscli's output
       with debug messages.
     - 0015-silence-not-latest-version.patch: upstream maintains a hub
       branch for our stable release (Closes: #1031323).
  * Rework collections handling:

